# -*-coding:utf-8-*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      __init__.py
# Author:       why
# Datetime:     2024/9/7 上午9:12
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------
import logging
import os
import time


# 配置日志文件信息

def log(name="why"):
    # 创建logger对象
    logger = logging.getLogger(name)
    # 设置log级别
    logger.level = logging.INFO
    # 设置写入日志的文件
    log_name = time.strftime("%Y-%m-%d-%H-%M-%S", time.localtime())+".log"
    log_dir_path = os.path.join(os.path.join(os.path.dirname(__file__), "report"), "log")
    log_path = os.path.join(log_dir_path, log_name)
    handle = logging.FileHandler(log_path, mode="a", encoding="utf-8")
    # 设置日志的显示格式
    formatter = logging.Formatter('%(asctime)s - %(filename)s[line:%(lineno)d] - %(levelname)s: %(message)s -- %(name)s')
    # 设置日志文件中的日志格式
    handle.setFormatter(formatter)
    # 给logger对象添加日志文件
    logger.addHandler(handle)
    # 返回logger对象
    return logger


# 先执行一次log函数，获取函数返回值，之后就直接使用返回值写入日志
log = log()

