# -*-coding:utf-8-*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      read_json.py
# Author:       why
# Datetime:     2024/9/7 上午10:00
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------
import json
from apiAutoTest_v4 import log


def read_json(file_path):
    """根据json文件路径读取json文件"""
    # 先判断传入路径是否为字符串，再把json文件序列化为python对象
    if isinstance(file_path, str):
        try:
            with open(file_path, mode="r", encoding="utf-8") as f:
                return json.load(f)
        except Exception as e:
            log.error(f"读取json文件错误，错误原因可能是文件路径不存在，也可能是文件数据格式错误，传入路径为{file_path},错误为{e}")
            raise e
    else:
        log.error(f"传入json文件路径不为字符串，传入路径为{file_path}")
        raise ValueError("传入文件路径必须为字符串！")

