# -*-coding:utf-8-*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      read_project_ini.py
# Author:       why
# Datetime:     2024/9/7 上午9:21
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------
import configparser
import os

from apiAutoTest_v4 import log


class ReadProjectIni:
    def __init__(self):
        """获取ini文件路径并读取"""
        data_config_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "data_config")
        project_ini_path = os.path.join(data_config_path, "project_config.ini")
        self.conf = configparser.ConfigParser()
        self.conf.read(project_ini_path, encoding="utf-8")

    def get_host(self, key):
        """根据key获取host节点下被测系统的域名"""
        try:
            return self.conf.get("host", key)
        except Exception as e:
            log.error(f"使用方法get_host错误，形参传入key为{key}，错误为{e}")
            raise e

    def get_sql_connect_msg(self, key):
        """根据key获取sql节点下数据库连接信息"""
        try:
            return self.conf.get("sql", key)
        except Exception as e:
            log.error(f"使用方法get_sql_connect_msg错误，形参传入key为{key}，错误为{e}")
            raise e
