# -*-coding:utf-8-*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      read_user_ini.py
# Author:       why
# Datetime:     2024/9/7 上午9:48
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------
import configparser
import os

from apiAutoTest_v4 import log


class ReadUserIni:
    def __init__(self, user_dir_name):
        """获取ini文件路径，并读取"""
        # 获取数据配置层的目录路径
        data_config_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), "data_config")
        # 获取存放用户数据的路径
        self.user_data_path = os.path.join(data_config_path, user_dir_name)
        # 拼接用户的ini文件路径
        self.user_ini_path = os.path.join(self.user_data_path, "config.ini")
        # 创建configparser对象，并读取ini文件
        self.conf = configparser.ConfigParser()
        self.conf.read(self.user_ini_path, encoding="utf-8")

    def get_file_path(self, key):
        """获取file节点下各个key对应的文件路径"""
        try:
            log.info(f"开始执行get_file_path方法，传入形参key为{key}")
            file_name = self.conf.get("file", key)
        except Exception as e:
            log.error(f"执行get_file_path方法错误，传入形参key为{key}，错误为{e}")
            raise e
        else:
            # 完成文件路径的拼接
            return os.path.join(self.user_data_path, file_name)

    def get_table_name(self, key):
        """获取table节点下工作表名称"""
        try:
            return self.conf.get("table", key)
        except Exception as e:
            log.error(f"执行get_table_name方法错误，传入形参key为{key}，错误为{e}")
            raise e


if __name__ == '__main__':
    ini = ReadUserIni("demo")
    # D:\Project\PythonDoc\test62\test62\apiAutoTest_v3\data_config\demo\apiAutoTest.xlsx
    # D:\Project\PythonDoc\test62\test62\apiAutoTest_v3\data_config\demo\apiAutoTest.xlsx
    print(ini.get_file_path("excel"))