# -*-coding:utf-8-*- #
# ---------------------------------------------------------------------------
# ProjectName:   test62
# FileName:      request_method.py
# Author:       why
# Datetime:     2024/9/7 下午2:39
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# --------------------------------------------------------------------------
import requests

from apiAutoTest_v4.common.read_project_ini import ReadProjectIni
from apiAutoTest_v4.data_config.settings import *


class RequestMethod:
    def __init__(self):
        """登录系统并关联token"""
        # 创建ReadProjectIni对象，调用get_host获取被测系统域名
        pro_ini = ReadProjectIni()
        login_url = pro_ini.get_host(HOST_KEY) + '/auth'
        login_data = {
                "username": "admin",
                "password": "bF6N3L93cX8pV6x2yEqxNjwIIPaEOYw9bNI5GuIY4g9MeoFyPFPL5WteHaV0LcxQ"
                                                 "qmDJWlhuCRMXzAPvrFcxJrA8BgGjJpmB1WMrQrazIJPbWbCfmDit2s2jzn+DRerV"
                                                 "lYIFojDM96y24drEniwWzHtaJKiWoc7LGL1csNmokvQ="
        }
        # 创建session对象，并发送请求
        self.session = requests.sessions.Session()
        res = self.session.request(method="post", url=login_url, json=login_data)
        # 获取token并更新到session的headers里
        token = res.json().get("token")
        self.session.headers["Authorization"] = f"Bearer {token}"

    def request_all(self, req_method, req_url, req_mime, case_data):
        """
        :param req_method: 发送请求的方法
        :param req_url: 发送请求的url
        :param req_mime: 发送请求的媒体类型
        :param case_data: 发送请求的用例数据
        :return: Response type
        """
        # json类型
        if req_mime == "application/json" or req_mime == "json":
            return self.session.request(method=req_method, url=req_url, json=case_data)
        # 表单类型
        elif req_mime == "application/x-www-form-urlencoded" or req_mime == "form":
            # 除了上传文件和json类型在请求体中传参以外，其他类型的数据全部使用data关键字传参。
            return self.session.request(method=req_method, url=req_url, data=case_data)
        # files类型
        elif req_mime == "multipart/form-data" or req_mime == "form-data":
            return self.session.request(method=req_method, url=req_url, files=case_data)
        # params类型
        elif req_mime == "query" or req_mime == "params":
            return self.session.request(method=req_method, url=req_url, params=case_data)
        # 无传参
        elif req_mime is None:
            return self.session.request(method=req_method, url=req_url)

        # 判断媒体类型是否为query|json 或 json|query，是则在地址栏和请求体同时传参
        elif req_mime == "query|json" or req_mime == "json|query":
            # requests是支持地址栏和请求体同时传参的。地址栏使用params传参，请求体根据不同的媒体类型选择不同的关键字传参。
            return self.session.request(method=req_method, url=req_url, json=case_data["body"], params=case_data["query"])




